/*******************************************************************************
* FILE NAME: main.c <VEX VERSION>
*
* DESCRIPTION:
*  This file contains the main program loop.
*
* USAGE:
*  You should not need to modify this file.
*  Note the different loop speed for the two routines:
*     Process_Data_From_Master_uP
*     Process_Data_From_Local_IO
*******************************************************************************/

#include "ifi_aliases.h"
#include "ifi_default.h"
#include "ifi_utilities.h"
#include "user_routines_parallel.h"
#include "my_types.h"
//#include "viport.h"

//*****************************************************************************************************
  


/*

 
#define IO1             TRISAbits.TRISA0
#define IO2             TRISAbits.TRISA1
#define IO3             TRISAbits.TRISA2
#define IO4             TRISAbits.TRISA3
#define IO5             TRISAbits.TRISA5
#define IO6             TRISFbits.TRISF0
#define IO7             TRISFbits.TRISF1
#define IO8             TRISFbits.TRISF2
#define IO9             TRISFbits.TRISF3
#define IO10            TRISFbits.TRISF4
#define IO11            TRISFbits.TRISF5
#define IO12            TRISFbits.TRISF6
#define IO13            TRISHbits.TRISH4
#define IO14            TRISHbits.TRISH5
#define IO15            TRISHbits.TRISH6
#define IO16            TRISHbits.TRISH7  

// Aliases used to read the pins when used as INPUTS. 
#define rc_dig_in01     PORTAbits.RA0
#define rc_dig_in02     PORTAbits.RA1
#define rc_dig_in03     PORTAbits.RA2
#define rc_dig_in04     PORTAbits.RA3
#define rc_dig_in05     PORTAbits.RA5
#define rc_dig_in06     PORTFbits.RF0
#define rc_dig_in07     PORTFbits.RF1
#define rc_dig_in08     PORTFbits.RF2
#define rc_dig_in09     PORTFbits.RF3
#define rc_dig_in10     PORTFbits.RF4
#define rc_dig_in11     PORTFbits.RF5
#define rc_dig_in12     PORTFbits.RF6
#define rc_dig_in13     PORTHbits.RH4
#define rc_dig_in14     PORTHbits.RH5
#define rc_dig_in15     PORTHbits.RH6
#define rc_dig_in16     PORTHbits.RH7

// Aliases used to drive the pins when used as OUTPUTS. 
#define rc_dig_out01    LATAbits.LATA0
#define rc_dig_out02    LATAbits.LATA1
#define rc_dig_out03    LATAbits.LATA2
#define rc_dig_out04    LATAbits.LATA3
#define rc_dig_out05    LATAbits.LATA5
#define rc_dig_out06    LATFbits.LATF0
#define rc_dig_out07    LATFbits.LATF1
#define rc_dig_out08    LATFbits.LATF2
#define rc_dig_out09    LATFbits.LATF3
#define rc_dig_out10    LATFbits.LATF4
#define rc_dig_out11    LATFbits.LATF5
#define rc_dig_out12    LATFbits.LATF6
#define rc_dig_out13    LATHbits.LATH4
#define rc_dig_out14    LATHbits.LATH5
#define rc_dig_out15    LATHbits.LATH6
#define rc_dig_out16    LATHbits.LATH7

 // Hardware interface with the  MAX7219 (using PIC18C452 Pin numbering)

#define DataPin1       PORTFbits.RF3      // Bits are shifted out this pin # to the MAX7219.
#define ClockPin1      PORTFbits.RF4      // Data valid on rising edge of this clock (pin RD5).
#define LoadPin1       PORTFbits.RF5      // This control pin tells the 7219 to transfer data to LEDs.  

#define DataPin0       PORTFbits.RF3        // Bits are shifted out this pin # to the MAX7219.
#define ClockPin0      PORTFbits.RF4        // Data valid on rising edge of this clock (pin RD5).
#define LoadPin0       PORTFbits.RF5        // This control pin tells the 7219 to transfer data to LEDs.
*/



 
// Declare gobal types here 

tx_data_record txdata;          /* DO NOT CHANGE! */
rx_data_record rxdata;          /* DO NOT CHANGE! */
packed_struct statusflag;       /* DO NOT CHANGE! */




/*******************************************************************************
* FUNCTION NAME: main
* PURPOSE:       Main program function.
* CALLED FROM:   ifi_startup.c
* ARGUMENTS:     none
* RETURNS:       void
* DO NOT DELETE THIS FUNCTION 
*******************************************************************************/
void main (void)
{
	int i;   // Local loop index
	int j;   // Local loop index
    byte Data_Byte = 0;   // Local data byte to be read or written
    int KeyValue = 0;



#ifdef UNCHANGEABLE_DEFINITION_AREA
  IFI_Initialization ();        /* DO NOT CHANGE! */
#endif

  statusflag.NEW_SPI_DATA = 0;  /* DO NOT CHANGE! */ 

	// I/O Pins used by the Vex Controller 
	//IO9 = IO10 = IO11 = IO12 = IO13 = 0;

  // Initialize ports used for 8-bit parallel port in user_routines.c 
  User_Initialization();        /* You edit this in user_routines.c */

#if ENABLE_AUTONOMOUS_MODE
  txdata.user_cmd = 0x02;       /* Tell master you want to be in auton mode. */
#endif
 

  // Setup timers, configure ports and initialize variables.  Works!!!
  SetupTimers();  

  // Server configuration
  IO9 = IO10 = IO11 = INPUT;      /* Used for Parallel Port control signals CS, WR, RD. */
  IO12 = OUTPUT;    /* Used for BUSY for Master */

  // Client configuration
  //IO9 = IO10 = IO11 = OUTPUT;      /* Used for Parallel Port control signals CS, WR, RD. */
  //IO12 = INPUT;    /* Used for BUSY for Master */
  
  // Set Parallel Port direction to input
  //IO1 = IO2 = IO3 = IO4 = IO5 = IO6 = IO7 =IO8 = INPUT;      /* Used for limit switch inputs and parallel port. */

  // Set Parallel Port direction to output
  IO1 = IO2 = IO3 = IO4 = IO5 = IO6 = IO7 =IO8 = OUTPUT;      /* Used for limit switch inputs and parallel port. */
  IO14 = OUTPUT;      // LED 14
  IO15 = OUTPUT;      // LED 15
  IO16 = OUTPUT;      // LED 16

  // Test LEDs
  rc_dig_out14   = OFF; // LED 14
  rc_dig_out15   = OFF; // LED 15   
  rc_dig_out16   = OFF; // LED 16 

/*
  while (1)
  {
      rc_dig_out14   = ~rc_dig_out14; // LED 14
      rc_dig_out15   = ~rc_dig_out15; // LED 15 
      rc_dig_out16   = ~rc_dig_out16; // LED 16
      pause(500); 
 
  }
*/
                                                     // variables. 
  
   printf("\r\n Initializing the Vex Keypad Application... \r\n"); 

  pause(500); 
 
   // Initialize the LCD Display

	InitializeLCD();

   // Test the LCD Display
 	 while (1)   // Forever
  	{
 		for (i=0; i<255; i++)
		{
			printf("Testing %d times!!!\n", i);
			pause(500);
			
		}
    }

// Configure ports and initialize variables used by the Keypad application
    InitializeKeypad();
 
    while(1)
    {
        lcd_clear();  
  	    printf("Enter key:  \r\n");
  
    	//KeyValue = GetKey() - 48;			// Convert the key value from ASCII to binary
    	KeyValue = GetKey();				// Convert the key value from ASCII to binary
  
    	// Send the scanned key to the host

    	printf("Key pressed = %d \r\n", KeyValue);
     
   	 

    }

   // Test the LCD Display
 	 while (1)   // Forever
  	{
 		for (i=0; i<255; i++)
		{
			printf("Testing %d times!!!\n", i);
			pause(500);
			
		}
    }

	while (1)   // Forever
  	{
 		// Run LCD Tests
        WriteLCD('H');
        WriteLCD('e');
        WriteLCD('l');
        WriteLCD('l');
        WriteLCD('o');
        WriteLCD(' ');
        WriteLCD('W ');
        WriteLCD('o ');
        WriteLCD('r ');
        WriteLCD('l ');
        WriteLCD('d ');
   } 
   // Initialize the Parallel Port
   Initialize_Parallel_Port();

     //******************************************************************************************  
     //* Test Client application
     //******************************************************************************************  
     while(1)
     {
     }
 
     //******************************************************************************************  
     //* Test  writing data to Parallel Port. Works!!!
     //******************************************************************************************  
     while(1)
     {
        for (i=0; i<255; i++)
        {
           // Write a byte of data to the co-processor
           Write_Byte(i);
           //Write_Byte(0xAA);
 
        }
      }

  
    //******************************************************************************************  
    // Test reading from the 8-Bit parallel port here.  Works!!!
    //******************************************************************************************  
    while(1)
    {
       for (i=0; i<255; i++)
       {
         // Write a byte of data to the co-processor
         Data_Byte = Read_Byte();
         //PrintToScreen("Data_Byte = %d \r\n", Data_Byte); 
         printf("Data_Byte = %d \r\n", Data_Byte); 
         //Wait(500);
       }
     }

#ifdef TEST
 /* Test the digital output pins */  // Works here!!!
 TRISFbits.TRISF3 = 0;
 TRISFbits.TRISF4 = 0;
 TRISFbits.TRISF5 = 0;

while (1)
{
 LATFbits.LATF3 = 1;
 LATFbits.LATF4 = 1;
 LATFbits.LATF5  = 1;
 for(i=0; i<10000; i++);

 LATFbits.LATF3 = 0;
 LATFbits.LATF4 = 0;
 LATFbits.LATF5 = 0;
 for(i=0; i<10000; i++);
}
#endif

#ifdef NEW_CODE
  // Test  writing data to Parallel Port. Works!!!
  WR_BAR = HIGH;
  CS_BAR = HIGH;
  while(1)
  {
     for (i=0; i<4; i++)
     {
        LATA = i;
 
        // Check if co-processor is busy
        while (rc_dig_in12);  

        // Write 8-Bits to the Parallel Port   
        WR_BAR = LOW;
        pause(1);
        // Write 8-Bits to the Parallel Port   
        WR_BAR = HIGH;
        pause(1);
 
     }
  }


  // Test  writing data to Parallel Port. Works!!!
   WR_BAR = HIGH;
   CS_BAR = HIGH;

      rc_dig_out01 = LOW;
      rc_dig_out02 = LOW;
      rc_dig_out03 = LOW;
      rc_dig_out04 = LOW;
      rc_dig_out05 = LOW;
      rc_dig_out06 = LOW;
      rc_dig_out07 = LOW;
      rc_dig_out08 = LOW;

  while (1)
   {
      rc_dig_out01 = ~rc_dig_out01;
      rc_dig_out02 = ~rc_dig_out02;
      rc_dig_out03 = ~rc_dig_out03;
      rc_dig_out04 = ~rc_dig_out04;
      rc_dig_out05 = ~rc_dig_out05;
      rc_dig_out06 = ~rc_dig_out06;
      rc_dig_out07 = ~rc_dig_out07 ;
      rc_dig_out08 = ~rc_dig_out08;

      //pause(500);   // Wait a bit.  Works!!!
      for(i=0; i<10000; i++);


      // Write 8-Bits to the Parallel Port   
      WR_BAR = LOW;
      pause(1);
      // Write 8-Bits to the Parallel Port   
      WR_BAR = HIGH;
      pause(1);
      //pause(500);   // Wait a bit.  Works!!!
      //for(i=0; i<10000; i++);

   }     

 // Test  Parallel Port Write control signals. Works!!!
   WR_BAR = 0;
   //CS_BAR = 0;

   while (1)
   {
     // send RD commands to the dsPIC30F6014 coprocessor 
     WR_BAR = ~WR_BAR;
     //CS_BAR = ~CS_BAR;
     //for(i=0; i<10000; i++);
     //for(i=0; i<10000; i++);

      pause(500);   // Wait a bit.  Works!!!
   }     



 // Test  Parallel Port Read control signals. Works!!!
   RD_BAR = 0;
  //CS_BAR = 0;

   while (1)
   {
     // send RD commands to the dsPIC30F6014 coprocessor 
     RD_BAR = ~RD_BAR;
     //CS_BAR = ~CS_BAR;
     //for(i=0; i<10000; i++);
     //for(i=0; i<10000; i++);

      pause(500);   // Wait a bit.  Works!!!
   }     

 
   // Test  Parallel Port Read control signals. Works!!!
   RD_BAR = 0;
  //CS_BAR = 0;

   while (1)
   {
     // send RD commands to the dsPIC30F6014 coprocessor 
     RD_BAR = ~RD_BAR;
     //CS_BAR = ~CS_BAR;
     //for(i=0; i<10000; i++);
     //for(i=0; i<10000; i++);

      pause(500);   // Wait a bit.  Works!!!
   }     


 
   // Test  reading data to Parallel Port. 
   RD_BAR = HIGH;
   CS_BAR = HIGH;

   while (1)
   {
      // Read 8-Bits from the Parallel Port   
      RD_BAR = LOW;
      pause(500);   // Wait a bit.  Works!!!

      // Write 8-Bits to the Parallel Port   
      RD_BAR = HIGH;
      pause(500);   // Wait a bit.  Works!!!

   }     

#ifdef TEST
// Test  Parallel Port control signals. Works!!!
   RD_BAR = 0;
   WR_BAR = 0;
   CS_BAR = 0;

   while (1)
   {
     // send RD commands to the dsPIC30F6014 coprocessor 
     RD_BAR = ~RD_BAR;
     WR_BAR = ~WR_BAR;
     CS_BAR = ~CS_BAR;
     //for(i=0; i<10000; i++);
     //for(i=0; i<10000; i++);

      pause(500);   // Wait a bit.  Works!!!
   }     
#endif

     
 /* Test the digital output pins */  // Works here!!!
 


   printf("\r\n Initializing the Vex Parallel Interface... \r\n"); 
   RD_BAR = 0;
   WR_BAR = 0;
   CS_BAR = 0;

    // Test the parallel port Write function here.
    while (1)
    {
		for (i=0; i<256; i++)
		{
        	Data_Byte = (byte) i;
        	//PrintToScreen("Write Data Byte is %04X\r\n", i); 
        //	printf("Write Data Byte is %d\r\n", i); 
        	Write_Byte(Data_Byte);

       		 // Wait a bit
       		 //Wait(5000); 
      		 //pause(500); 
             for(j=0; j<10000; j++);		
        }
    }     
  

   RD_BAR = 0;
   WR_BAR = 0;
   CS_BAR = 0;

   while (1)
   {
     // send RD commands to the dsPIC30F6014 coprocessor 
     RD_BAR = ~RD_BAR;
     WR_BAR = ~WR_BAR;
     CS_BAR = ~CS_BAR;
     for(i=0; i<10000; i++);

    // pause(500);
   }     
                                                     // variables. 
   pause(3000);
   printf("\r\n Initializing the Vex Parallel Interface... \r\n"); 

	// My own startup code          // dfr
    // Initialize the MAX7219 LED Display
//	InitializeParallelInterface();

  printf("Testing Parallel Interface...\r\n");
   RD_BAR = 0;
   WR_BAR = 0;
   CS_BAR = 0;

   while (1)
   {
     // send RD commands to the dsPIC30F6014 coprocessor 
     RD_BAR = ~RD_BAR;
     WR_BAR = ~WR_BAR;
     CS_BAR = ~CS_BAR;
     pause(500);
   }

#endif 
  

/*

	// Test the LEDs 
    while (1)
	{
		for (i=0; i<256; i++)
		{
			PORTA = i;
			pause(1000);
		}
	}
	while(1)
	{
      	for (j=0; j<4; j++)
		{
		 
  			SetBit((byte *)&PORTA, j);
        	pause(1000);
		}
   
 
	}



     	ClearBit((byte *)&PORTD,  BIT_0); 
       	ClearBit((byte *)&PORTD,  BIT_1); 
       	ClearBit((byte *)&PORTD,  BIT_2); 

      	Bit0 = GetBit((byte *)&PORTD,  BIT_0); 
       	Bit1 = GetBit((byte *)&PORTD,  BIT_1); 
       	Bit2 = GetBit((byte *)&PORTD,  BIT_2); 

       	ComplementBit((byte *)&PORTD,  BIT_0); 
       	ComplementBit((byte *)&PORTD,  BIT_1); 
       	ComplementBit((byte *)&PORTD,  BIT_2); 
  
*/

  while (1)   /* This loop will repeat indefinitely. */
  {
 
  } /* while (1) */

}  /* END of Main */



/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
#ifdef NEW_CODE
//******************************************************************************************
//* Read_Byte -  This routine reads a byte of data from the 8-Bit parallel interface into the 
//* Vex Controller.
//******************************************************************************************
byte Read_Byte(void)
{
	byte Data_Byte = 0;
	//PrintToScreen("Entering Read_Byte...\r");
    //BUSY_BAR_TRIS = 1;    	// Set BUSY_BAR pin direction to input         
    //RD_BAR_TRIS = 0;        // Set RD_BAR pin direction to output       
   
  	//PrintToScreen("Trace 1\r");

    // Check if co-processor is busy
    //while (rc_dig_in12);  

	// Copy the Data byte to the 8-Bit parallel port

	// Set signal RD_BAR to LOW indicating to the PIC18F4550 USB Controller that it can put a byte of data
	// on the parallel bus so that it can be read in by the Vex Controller.   
	//RD_BAR = 0;
    SetDigitalOutput(RD_BAR, LOW);
   // Wait a bit
   // pause(1);

	// Set signal RD_BAR to HIGH indicating to the PIC18F4550 USB Controller that it can put a byte of data
	// on the parallel bus so that it can be read in by the Vex Controller.   
	//RD_BAR = 1;
 

	SetDigitalOutput(RD_BAR, HIGH);

   // Wait a bit
   // pause(1);

	//PrintToScreen("Trace 2\r");

 
	// Read the data from the 8-Bit Parallel Port
	VR_Port_Data = Read_Virtual_Port(PORT_A);
	//PrintToScreen("Leaving Read_Byte.\r");
   
	// Return the data byte
	return VR_Port_Data.Port_Value;
}


//******************************************************************************************
//* Write_Byte -  This routine writes a byte of data to the 8-Bit parallel interface so that
//* it can be read and processed by the PIC18F4550 USB Controller
//******************************************************************************************
 void Write_Byte(byte Data)
{ 
	//PrintToScreen("Entering Write_Byte...\r");
   
    //BUSY_BAR_TRIS = 1;    	// Set BUSY_BAR pin direction to input         
    //WR_BAR_TRIS = 0;        // Set RD_BAR pin direction to output       

  	//PrintToScreen("Trace 1\r");
	
	//PrintToScreen("Data_Byte read = %d \r", BUSY_BAR);
	//PrintToScreen("Data_Byte read = %d \r", PORTFbits.RF5);

 	//PrintToScreen("Trace 2\r");

	// Copy the Data byte to the 8-Bit parallel port
 	VR_Port_Data.Port_Value = Data;
	Write_Virtual_Port(PORT_A, VR_Port_Data);
 
    // Check if co-processor is busy
    //while (rc_dig_in12);  

 	//PrintToScreen("Trace 3\r");
  
 	// Signal WR_BAR to LOW indicate to the PIC18F4550 USB Controller that there is valid data
	// on the parallel bus that needs to be read and processed.  
	//WR_BAR = 0;
    SetDigitalOutput(WR_BAR, LOW);

    // Wait a bit
   // pause(1);

 	// Signal WR_BAR to HIGH indicate to the PIC18F4550 USB Controller that there is valid data
	// on the parallel bus that needs to be read and processed.  
	//WR_BAR = 0;

    SetDigitalOutput(WR_BAR, HIGH);

    // Wait a bit
    //pause(1);
	//PrintToScreen("Leaving Write_Byte\r");

}

#endif

/***************************************************************************************
 * IO_Initialization -  This procedure initializes the Vex Controller and I/O Ports. 
 ***************************************************************************************/
void IO_Initialization(void)
{ 
//	SetCompetitionMode(0,1); // VEX Runs main
  //SetCompetitionMode(1, 1); // VEX
 
   //Controller Port   #: 01,02,03,04,05,06,07,08,09,10,11,12,13,14,15,16 
   //DefineControllerIO(4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0); 
   // The first parameter is the number of analog input ports.
   //                         01     02     03     04     05     06     06     07     08     09      10      11     12       13      14      15      16
   //DefineControllerIO ( 5, INPUT ,INPUT ,INPUT ,INPUT ,INPUT ,INPUT ,INPUT ,INPUT ,INPUT ,INPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT, OUTPUT) ;
  // DefineControllerIO ( 2, INPUT ,INPUT ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ) ;
   //DefineControllerIO (   0, INPUT ,INPUT ,INPUT  ,INPUT  ,INPUT  ,INPUT  ,INPUT  ,INPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ) ;
  // DefineControllerIO (   0, OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ) ;
  

  // DefineControllerIO (   0, OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,OUTPUT  ,INPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ,OUTPUT ) ;
        
  // Set all data and control pins to inputs
  IO1 = IO2 = IO3 = IO4 = IO5 = IO6 = IO7 = IO8 = IO9 = IO10 = IO11 = INPUT;

  // READY Bar status line is set to output
  IO12 = OUTPUT; 

} 
