/*******************************************************************************
* FILE NAME: main.c <VEX VERSION>
*
* DESCRIPTION:
*  This file contains the main program loop.
*
* USAGE:
*  You should not need to modify this file.
*  Note the different loop speed for the two routines:
*     Process_Data_From_Master_uP
*     Process_Data_From_Local_IO
*******************************************************************************/

#include "ifi_aliases.h"
#include "ifi_default.h"
#include "ifi_utilities.h"
#include "user_routines.h"
#include "lcd.h"
 
#define ENABLE_AUTONOMOUS_MODE   0

tx_data_record txdata;          /* DO NOT CHANGE! */
rx_data_record rxdata;          /* DO NOT CHANGE! */
packed_struct statusflag;       /* DO NOT CHANGE! */
//int Buffer[80];  // Output string buffer

/*******************************************************************************
* FUNCTION NAME: main
* PURPOSE:       Main program function.
* CALLED FROM:   ifi_startup.c
* ARGUMENTS:     none
* RETURNS:       void
* DO NOT DELETE THIS FUNCTION 
*******************************************************************************/
void main (void)
{
	int i;

 

#ifdef UNCHANGEABLE_DEFINITION_AREA
  IFI_Initialization ();        /* DO NOT CHANGE! */
#endif

  statusflag.NEW_SPI_DATA = 0;  /* DO NOT CHANGE! */ 
  //User_Initialization();        /* You edit this in user_routines.c */

#if ENABLE_AUTONOMOUS_MODE
  txdata.user_cmd = 0x02;       /* Tell master you want to be in auton mode. */
#endif

 // Setup timers, configure ports and initialize variables

    SetupTimers();  

	// My own startup code          // dfr
    // Initialize the LCD Display
	InitializeLCD();



 
	 while (1)   // Forever
  	{
 		for (i=0; i<255; i++)
		{
			printf("Testing %d times!!!\n", i);
			pause(500);
			
		}
    }



	while (1)   // Forever
  	{
 		// Run LCD Tests
        WriteLCD('H');
        WriteLCD('e');
        WriteLCD('l');
        WriteLCD('l');
        WriteLCD('o');
        WriteLCD(' ');
        WriteLCD('W ');
        WriteLCD('o ');
        WriteLCD('r ');
        WriteLCD('l ');
        WriteLCD('d ');

 	// Wait 1 second between words for pacing

  	pause(1000);  
  }
		
 /* 
 	// Test the LEDs 
    while (1)
	{
		for (i=0; i<256; i++)
		{
			PORTA = i;
			pause(1000);
		}
	}

*/
 	//while (1)   // Forever
  	//{
 		// Run LCD Tests
        lcd_putc('A');
        lcd_putc('B');
        lcd_putc('C');
        lcd_putc('D');
        lcd_putc('E');
        lcd_putc('F');

   		//lcd_test_1();
   		//lcd_test_2();
   		//lcd_test_3();
   		//lcd_test_4();
	//}
  

  while (1)   /* This loop will repeat indefinitely. */
  {
 
  } /* while (1) */

}  /* END of Main */


/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
