    // VEX User Interface (UI)
    // This is a practical example that allows you to enter the speed 
    // for a specific VEX Motor Display and display it on the LCD.
 
    // Define a robot two wheels using WPILIB 
    TwoWheelDrive(1, 2);  // This code works!!!
 
    // Clear the LCD and move the cursor to home position
    lcd_clear();
 
    //Format the Message to be displayed on the LCD 
    Buffer[0] = 'E';
    Buffer[1] = 'n';
    Buffer[2] = 't';
    Buffer[3] = 'e';
    Buffer[4] = 'r';
    Buffer[5] = ' ';
    Buffer[6] = 'S';
    Buffer[7] = 'p';
    Buffer[8] = 'e';
    Buffer[9] = 'e';
    Buffer[10] = 'd';
    Buffer[11] = '(';
    Buffer[12] = '0';
    Buffer[13] = '.';
    Buffer[14] = '.';
    Buffer[15] = '2';
    Buffer[16] = '5';
    Buffer[17] = '5';
    Buffer[18] = ')';
    Buffer[19] = ':';      
    Buffer[20] = 0;     // String terminator (null character)  

    // Position the cursor to the first line
    lcd_goto(0,2);
 
    // Send message to the LCD Display
    lcd_puts((char *) Buffer);  

    // Send message to the Serial Terminal if available
  	printf("Enter Speed (0..255) \r\n", KeyValue);

    //Format the Message to be displayed on the LCD 
    Buffer[0] = 'S ';
    Buffer[1] = 'p';
    Buffer[2] = 'e';
    Buffer[3] = 'e';
    Buffer[4] = 'd';
    Buffer[5] = ' ';
    Buffer[6] = '=';
    Buffer[7] = ' ';
    Buffer[8] = 0;     // String terminator (null character)
 
    Speed = 0;
    i = 0;
    while(1)
    { 
     	KeyValue = GetKey();				// Convert the key value from ASCII to binary

        // Check the range of the Key Value to make sure is a digit between 0 and 9
        if ((KeyValue >=0) && (KeyValue <=9))
        {
           // Enter the Speed one digit at a time
     
           if (i<3)  
           {
              Speed += (int)KeyValue*PowerOfTen[i];
              i++;
          
              // Position the cursor
              lcd_goto(1,2);
 
              // Display formatted text to the LCD
    	      lcd_puts((char *) Buffer);  
              lcd_printdec(Speed);
           }
           else
           {
              // Set the VEX Motor # 1 Speed 
	          SetPWM (1,Speed);
           
              // Reset digit count and Speed
              i = 0;
              Speed = 0;
           }
        }
        else if (KeyValue == ENTER)
        {
           // Process the speed value entered 
   	       // Send the scanned key to the host serial terminal also
       	   printf("Current Motor Speed = %d \r\n", Speed);
 
           // Set the VEX Motor # 1 Speed 
	       SetPWM (1,Speed);
 
           // Reset digit count and Speed
           i = 0;
           Speed = 0;
        }
    }
